var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "event-checker.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

var Utf8 = {
	    // public method for url encoding
	    encode : function (string) {
	        string = string.replace(/\r\n/g,"\n");
	        var utftext = "";
	        for (var n = 0; n < string.length; n++) {
	            var c = string.charCodeAt(n);
	            if (c < 128) {
	                utftext += String.fromCharCode(c);
	            }
	            else if((c > 127) && (c < 2048)) {
	                utftext += String.fromCharCode((c >> 6) | 192);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	            else {
	                utftext += String.fromCharCode((c >> 12) | 224);
	                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	        }
	        return utftext;
	    }
	};



function storeSubParameter(path,value)
{
	Property.setProperty('thresholds/' + path, value);
	Property.setFlag('thresholds/' + path, 'ARCHIVE', true);
}



function putConditionParameter(idValue,oParameterObject) {
	var succeded = true;
	if (oParameterObject.conditions==null)
		return succeded;
	var sSubpath=idValue + '/conditions/';
	if (oParameterObject.conditions.enabled!=null) {
		if (oParameterObject.conditions.enabled==true)
			storeSubParameter(sSubpath + 'enabled', true);
		else 
			storeSubParameter(sSubpath + 'enabled', false);
	}	
	if (oParameterObject.conditions.weekdays!=null) {
		var sString="";
		for (var iIndex=0;iIndex<oParameterObject.conditions.weekdays.length;iIndex++) {
			var sWeekday=oParameterObject.conditions.weekdays[iIndex];
			switch (sWeekday)
			{
				case 'SU':
					sString += '0,';
				break;
				case 'MO':
					sString += '1,';
				break;
				case 'TU':
					sString += '2,';
				break;
				case 'WE':
					sString += '3,';
				break;
				case 'TH':
					sString += '4,';
				break;
				case 'FR':
					sString += '5,';
				break;
				case 'SA':
					sString += '6,';
				break;
			}	
		}
		if (sString!="") {
			sString=sString.substr(0,sString.length-1);
			storeSubParameter(sSubpath + 'weekdays', sString);
		}
	}	
	if (oParameterObject.conditions.systemState!=null) {
		for (var iIndex=0;iIndex<oParameterObject.conditions.systemState.length;iIndex++){
			var sStateName=oParameterObject.conditions.systemState[iIndex].name;
			var sStateValue=oParameterObject.conditions.systemState[iIndex].value;
			if (sStateValue==='false')
				sStateValue=false;
			if (sStateValue==='true')
				sStateValue=true;
			storeSubParameter(sSubpath + 'states/' + sStateName,sStateValue);
		}
	}	
	if (oParameterObject.conditions.addonStates!=null) {
		for (var sAddonId in oParameterObject.conditions.addonStates) {
			for (var iIndex=0;iIndex<oParameterObject.conditions.addonStates[sAddonId].length;iIndex++){
				var sStateName=oParameterObject.conditions.addonStates[sAddonId][iIndex].name;
				var sStateValue=oParameterObject.conditions.addonStates[sAddonId][iIndex].value;
				if (sStateValue==='false')
					sStateValue=2;
				if (sStateValue==='true')
					sStateValue=1;
				if (sStateValue===false)
					sStateValue=2;
				if (sStateValue===true)
					sStateValue=1;
				storeSubParameter(sSubpath + 'addon-states/' + sAddonId + '/' + sStateName,sStateValue);
			}
		}
	}	
	if (oParameterObject.conditions.zoneState!=null) {
		for (var iIndex=0;iIndex<oParameterObject.conditions.zoneState.length;iIndex++){ 
			var zoneID=oParameterObject.conditions.zoneState[iIndex].zone;
			var groupID=oParameterObject.conditions.zoneState[iIndex].group;
			var sceneID=oParameterObject.conditions.zoneState[iIndex].scene;
			
			succeded = checkAndStoreIntParameter(sSubpath + 'zone-states/' + iIndex + '/zone' , zoneID) ? succeded : false;
			succeded = checkAndStoreIntParameter(sSubpath + 'zone-states/' + iIndex + '/group' , groupID) ? succeded : false;
			succeded = checkAndStoreIntParameter(sSubpath + 'zone-states/' + iIndex + '/scene' , sceneID) ? succeded : false;
		}
	}	
	if (oParameterObject.conditions.timeframe!=null) {
		for (var iIndex=0;iIndex<oParameterObject.conditions.timeframe.length;iIndex++){ 
			var from=oParameterObject.conditions.timeframe[iIndex].start;
			var to=oParameterObject.conditions.timeframe[iIndex].end;
			var sFromBase=from.timeBase;
			var sFromOffset=from.offset;
			var sToBase=to.timeBase;
			var sToOffset=to.offset;
			lInfo.logln('from ' + sFromBase + ' off ' + sFromOffset + ' to  ' + sToBase + ' off ' + sToOffset);
			if (sFromBase=='daily')
				if (sToBase=='daily'){
					storeSubParameter(sSubpath + 'time-start' , Math.floor(parseInt("" + sFromOffset,10)/3600) + ':' + Math.floor(parseInt("" + sFromOffset,10)/60)%60 + ':' + Math.floor(parseInt("" + sFromOffset,10)%60));
					storeSubParameter(sSubpath + 'time-end'  , Math.floor(parseInt("" + sToOffset,10)/3600) + ':' + Math.floor(parseInt("" + sToOffset,10)/60)%60 + ':' + Math.floor(parseInt("" + sToOffset,10)%60));
				}
		}	
	}		
	if (oParameterObject.conditions.date!=null) {
		for (var iIndex=0;iIndex<oParameterObject.conditions.date.length;iIndex++){
			var from=oParameterObject.conditions.date[iIndex].start;
			var to=oParameterObject.conditions.date[iIndex].end;
			var rrule=oParameterObject.conditions.date[iIndex].rrule;
			
			storeSubParameter(sSubpath + 'date/' + iIndex + '/start' , from );
			storeSubParameter(sSubpath + 'date/' + iIndex + '/end'  , to);
			storeSubParameter(sSubpath + 'date/' + iIndex + '/rrule'  , rrule);
			
		}
	} 
	return succeded;
}



function putActionParameter(idValue,oParameterObject) {
	var iIndex;
	var succeded = true;
    for (iIndex = 0; iIndex < oParameterObject.actions.length; iIndex++) {
        var oSubobject = oParameterObject.actions[iIndex];
        switch (oSubobject.type) {
            case 'zone-scene':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false ;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone) ? succeded : false ;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/group', oSubobject.group) ? succeded : false ;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/scene', oSubobject.scene) ? succeded : false;
            	if (oSubobject.force!=null)
            		succeded = checkAndStoreBoolParameter(idValue + '/actions/' + iIndex + '/force', oSubobject.force) ? succeded : false;
            break;
            case 'undo-zone-scene':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/group', oSubobject.group) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/scene', oSubobject.scene) ? succeded : false;
            	if (oSubobject.force!=null)
            		succeded = checkAndStoreBoolParameter(idValue + '/actions/' + iIndex + '/force', oSubobject.force) ? succeded : false;
            break;
            case 'device-scene':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	succeded = checkAndStoreDSUIDParameter(idValue + '/actions/' + iIndex + '/dsuid' , oSubobject.dsuid, oSubobject.dsid) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/scene', oSubobject.scene) ? succeded : false;
            	if (oSubobject.force!=null)
            		succeded = checkAndStoreBoolParameter(idValue + '/actions/' + iIndex + '/force', oSubobject.force) ? succeded : false;
            break;
            case 'device-value':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/value', oSubobject.value) ? succeded : false;
            	succeded = checkAndStoreDSUIDParameter(idValue + '/actions/' + iIndex + '/dsuid' , oSubobject.dsuid, oSubobject.dsid) ? succeded : false;            
            break;
            case 'device-blink':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	succeded = checkAndStoreDSUIDParameter(idValue + '/actions/' + iIndex + '/dsuid' , oSubobject.dsuid, oSubobject.dsid) ? succeded : false;
            break;
            case 'zone-blink':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/group', oSubobject.group) ? succeded : false;
            break;
            case 'custom-event':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/event', oSubobject.event) ? succeded : false;
            break;
            case 'url':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/url', Utf8.encode(unescape(oSubobject.url))) ? succeded : false;
            break;
            case 'change-state':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	if (oSubobject.name!=null)
            		succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/statename" , oSubobject.name) ? succeded : false;
            	else
            		succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/statename" , oSubobject.statename) ? succeded : false;

               succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/state" , oSubobject.state);
            break;            
            case 'change-addon-state':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	if (oSubobject.name!=null)
            		succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/statename" , oSubobject.name) ? succeded : false;
            	else
            		succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/statename" , oSubobject.statename) ? succeded : false;

            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/addon-id" , oSubobject.addonId) ? succeded : false;
                succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/state" , oSubobject.state) ? succeded : false;
            break;
            case 'heating-mode':
                succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
                succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone) ? succeded : false;
                succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/mode', oSubobject.mode) ? succeded : false;
                if (oSubobject.reset!=null) {
                    succeded = checkAndStoreBoolParameter(idValue + '/actions/' + iIndex + "/reset" , oSubobject.reset) ? succeded : false;
                }
            break;
            default:
            	//unexpected type 
            	succeded = false;
            break;
        }
        if (oSubobject.delay!=null) {
        	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/delay', oSubobject.delay) ? succeded : false;
        }
        storeSubParameter(idValue + '/actions/' + iIndex + '/category', 'manual');
    }
    return succeded;
}

function getNewIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('thresholds');
    if (baseNode == null) {
        return idValue;
    }
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null) {
            if (oChildNode.getChild('id').getValue() != null) {
                if (parseInt("" + oChildNode.getChild('id').getValue(), 10) >= idValue) {
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(), 10) + 1;
                }
            }
        }
    }
    return idValue;
}

function storeValue(sValue) {
    try {
        var oParameterObject = JSON.parse(unescape(sValue));
        var idValue = null;
        
        if (oParameterObject.id != null) {
            idValue = oParameterObject.id;
        } else {
            idValue = getNewIdValue();
        }
        
        var baseNode = Property.getNode('thresholds');
        if (baseNode != null) {
            baseNode.removeChild(idValue);
        }
        //the unescape already ensures to be string
        storeSubParameter(idValue + '/name', Utf8.encode(unescape(oParameterObject.name)));
        storeSubParameter(idValue + '/id', idValue);
        storeSubParameter(idValue + '/conditions/enabled', true);
        if (!checkAndStoreIntParameter(idValue + '/delay', oParameterObject.delay)) {
            throw "wrong argument types";
        }
        if (oParameterObject.actions.length>0) {
            if (!putActionParameter(idValue,oParameterObject)) {
                throw "wrong argument types";
            }
        }
        if (!putConditionParameter(idValue,oParameterObject)) {
            throw "wrong argument types";
        }
        
        if (oParameterObject.trigger!=null) {
            storeSubParameter(idValue+'/trigger/scene',oParameterObject.trigger.scene);
            storeSubParameter(idValue+'/trigger/akm',oParameterObject.trigger.akm);
            for (var iIndex=0;iIndex<oParameterObject.trigger.deviceSensor.length;iIndex++) {
                storeSubParameter(idValue+'/trigger/deviceSensor/' + iIndex,oParameterObject.trigger.deviceSensor[iIndex]);
            }
        }
        
        if (oParameterObject.message.receiver!="") {
            storeSubParameter( idValue + '/message/messageType', oParameterObject.message.messageType);
            if (oParameterObject.message.messageType=="email") {
                storeSubParameter( idValue + '/message/receiver', oParameterObject.message.receiver);
                storeSubParameter( idValue + '/message/subject', Utf8.encode(unescape(oParameterObject.message.subject)));
                storeSubParameter( idValue + '/message/messageBody', Utf8.encode(unescape(oParameterObject.message.message)));
            }
        }
        
        Property.store();
        return true;
    } catch (e) {
        lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
            lWarn.logln(i + ': ' + e[i]);
        }
        //we could not store all data successfully so we cleanup
        baseNode.removeChild(idValue);
        return false;
    }
}

function convertdSID2dSUID(dSID) {
    try {
        //copy the first 6 bytes (12 characters to the new dsuid
        var dSUID = dSID.slice(0, 12);
        //insert 4 bytes of 0
        dSUID += '00000000';
        //append the remaining 6 bytes (12 chars) of the dsid
        dSUID += dSID.slice(12, 24);
        //finaly add 1 byte of 0
        dSUID += '00';
        return dSUID;
    } catch (e) {
        lWarn.logln('Exception in backward-compatibility::convertdSID2dSUID ' + e);
        return '';
    }
}


function updateActions2dSUID(actions) {
    try {
        var fMigrate=false;
        var dSID,dSUID;
        var subPropArray = actions.getChildren();
        lInfo.logln('Update action entries from dsid to dsuid');
        for (iIndex = 0; iIndex < subPropArray.length; iIndex++) {
            switch (subPropArray[iIndex].getChild('type').getValue()) {
                case 'device-scene': //intent fallthrough
                case 'device-blink': //intent fallthrough
                case 'device-value':
                    {   
                        if (subPropArray[iIndex].getChild('dsid')!=null) {
                            dSID = subPropArray[iIndex].getChild('dsid').getValue();
                            dSUID = convertdSID2dSUID(dSID);
                            Property.setProperty(subPropArray[iIndex].getPath()+'/dsuid',dSUID);
                            Property.setFlag(subPropArray[iIndex].getPath()+'/dsuid','ARCHIVE',true);  
                            subPropArray[iIndex].removeChild('dsid');
                            fMigrate = true;
                        }
                    }
                    break;
                case 'change-state': {
                    var actionName = subPropArray[iIndex].getChild('name').getValue();
                    var nameArray = actionName.split('.');
                    if ((nameArray[0] === 'dev') && (nameArray[1].length === 24)) {
                        var dsuid = convertdSID2dSUID(nameArray[1]);
                        actionName = '';
                        actionName = actionName.concat(nameArray[0],'.', dsuid, '.', nameArray[2]);
                        Property.setProperty(subPropArray[iIndex].getPath() + '/name', actionName);
                        Property.setFlag(subPropArray[iIndex].getPath()+'/name','ARCHIVE',true);  
                        fMigrate=true;
                    }

                }
                default: {lInfo.logln('--default nothing to do');}                
            }
        }
        return fMigrate;
    } catch (e) {
        lWarn.logln('Exception in backward-compatibility::updateActions2dSUID: ' + e);
        return fMigrate;
    }
}

function updateConditions2dSUID(conditions) {
    try {
        var fMigrate=false;
        lInfo.logln('Update condition entries from dsid to dsuid');
        var statesNode = conditions.getChild('states');
        if (statesNode != null ) {
            var statesArray = statesNode.getChildren();
            for (var jIndex = 0; jIndex < statesArray.length; jIndex++) {
                var stateName = statesArray[jIndex].getName();
                var stateValue = statesArray[jIndex].getValue();
                var nameArray = stateName.split('.');
                if ((nameArray[0] === 'dev') && (nameArray[1].length === 24)) {
                    var dsuid = convertdSID2dSUID(nameArray[1]);
                    lInfo.logln('Update from dsid ' + nameArray[1] +  ' to dsuid ' + dsuid);
                    newStateName = '';
                    newStateName = newStateName.concat('/',nameArray[0],'.', dsuid, '.', nameArray[2]);
                    Property.setProperty(statesNode.getPath() + newStateName, stateValue); 
                    Property.setFlag(statesNode.getPath() + newStateName,'ARCHIVE',true);  
                    lInfo.logln('set Property ' + statesNode.getPath() + newStateName+' to value '+stateValue);
                    statesNode.removeChild(stateName);
                    lInfo.logln('remove child  ' + stateName);
                    fMigrate=true;
                }
            }
        }

        return fMigrate;
    } catch (e) {
        lWarn.logln('Exception in backward-compatibility::updateConditions2dSUID: ' + e);
        return fMigrate;
    }    
}

function checkAndUpdateData()
{
	
	
    var iIndex;
    var subPropArray;
    var fMigrate=false;
    var tmpResult;
    var basePropertyArray = Property.getNode('thresholds');
    if (basePropertyArray !== null) {
        subPropArray = basePropertyArray.getChildren();
        for (iIndex = 0; iIndex < subPropArray.length; iIndex++) {
            tmpResult = updateActions2dSUID(subPropArray[iIndex].getChild('actions'));
            fMigrate = fMigrate || tmpResult;
            tmpResult = updateConditions2dSUID(subPropArray[iIndex].getChild('conditions'));
            fMigrate = fMigrate || tmpResult;
        }
    }
    if (fMigrate) {
        Property.store();
    } else {
        lInfo.logln('updateDSID2DSUID - nothing to update');
    }
	
}


if (raisedEvent.name=='running') {
	Property.load();
	checkAndUpdateData();
}

if (raisedEvent.name == 'event-checker-config') {
	Property.load();
    lInfo.logln("WD-Config param action " + raisedEvent.parameter.actions);
    if (raisedEvent.parameter.actions == 'save') {
        lInfo.logln("WD-Config param value " + unescape(raisedEvent.parameter.value));
        var success = storeValue(raisedEvent.parameter.value);
        Property.store();
        var evt;
        if (success) {
        	evt = new Event("event-checker.saved", {complete:'success'});
        } else {
        	evt = new Event("event-checker.saved", {complete:'failed'});
        }
        evt.raise();
    }
    
    
    if (raisedEvent.parameter.actions == 'enable') {
        lInfo.logln("WD-Config enable value " + raisedEvent.parameter.id);

        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        lWarn.logln(typeof(oIDObject));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
        	 lInfo.logln("SR-Config enable subvalue " + oIDObject[sKey] );
	        var sanityCheck = Property.getNode('thresholds/'+oIDObject[sKey]);
	        if (sanityCheck != null) {                
	            storeSubParameter(oIDObject[sKey] + '/conditions/enabled', true);
	        }
        }
        
        Property.store();
        var evt = new Event("event-checker.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'disable') {
        lInfo.logln("WD-Config disable value " + raisedEvent.parameter.id);
        
        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
	        var sanityCheck = Property.getNode('thresholds/'+oIDObject[sKey]);
	        if (sanityCheck != null) {                
	            storeSubParameter(oIDObject[sKey] + '/conditions/enabled', false);
	        }
        }
        
        Property.store();
        var evt = new Event("event-checker.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'activate') {
    	Property.setProperty('active', true);
    	Property.setFlag('active', 'ARCHIVE', true);
        Property.store();
        var evt = new Event("event-checker.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'deactivate') {
    	Property.setProperty('active', false);
    	Property.setFlag('active', 'ARCHIVE', true);
        Property.store();
        var evt = new Event("event-checker.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'delete') {
        lInfo.logln("WD-Config delete value " + raisedEvent.parameter.id);

        
        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
        	var baseNode = Property.getNode('thresholds');
	        if (baseNode != null) {
	            baseNode.removeChild(oIDObject[sKey]);
	            //unregisterTrigger(baseNode.getPath() + "/" + oIDObject[sKey]);
	        }
        }

        Property.store();
        var evt = new Event("event-checker.saved", {});
        evt.raise();
    }
}
